- job:
    name: networking-ovn-base
    description: Base job for devstack/tempest based networking-ovn jobs.
    parent: devstack-tempest
    timeout: 10800
    required-projects:
      - openstack/devstack-gate
      - openstack/networking-ovn
      - openstack/neutron
      - openstack/neutron-tempest-plugin
      - openstack/octavia
      - openstack/tempest
    irrelevant-files:
      - ^(test-|)requirements.txt$
      - ^.*\.rst$
      - ^doc/.*$
      - ^releasenotes/.*$
      - ^setup.cfg$
      - ^tools/.*$
      - ^tox.ini$
      - ^vagrant/.*$
      - ^migration/.*$
      - ^networking_ovn/locale/.*$
    vars:
      tox_envlist: all-plugin
      tempest_test_regex: "^(?!.*\
        (?:.*\\[.*slow.*\\])|\
        (?:tempest.api.network.admin.test_quotas.QuotasTest.test_lbaas_quotas.*)|\
        (?:tempest.api.network.test_load_balancer.*)|\
        (?:tempest.scenario.test_load_balancer.*)|\
        (?:tempest.api.network.admin.test_load_balancer.*)|\
        (?:tempest.api.network.admin.test_lbaas.*)|\
        (?:tempest.api.network.test_fwaas_extensions.*)|\
        (?:tempest.api.network.test_metering_extensions.*)|\
        (?:tempest.thirdparty.boto.test_s3.*)|\
        (?:tempest.scenario.test_network_basic_ops.TestNetworkBasicOps.test_port_security_macspoofing_port)|\
        (?:tempest.api.identity*)|\
        (?:tempest.api.image*)|\
        (?:tempest.api.volume*)|\
        (?:tempest.api.compute.images*)|\
        (?:tempest.api.compute.keypairs*)|\
        (?:tempest.api.compute.certificates*)|\
        (?:tempest.api.compute.flavors*)|\
        (?:tempest.api.compute.test_quotas*)|\
        (?:tempest.api.compute.test_versions*)|\
        (?:tempest.api.compute.volumes*)|\
        (?:tempest.api.compute.admin.test_flavor*)|\
        (?:tempest.api.compute.admin.test_volume*)|\
        (?:tempest.api.compute.admin.test_hypervisor*)|\
        (?:tempest.api.compute.admin.test_aggregate*)|\
        (?:tempest.api.compute.admin.test_quota*)|\
        (?:tempest.scenario.test_volume*))\
        ((^neutron_tempest_plugin.api)|\
        (^neutron_tempest_plugin.scenario)|\
        (tempest.(api|scenario|thirdparty))).*$"
      # TODO(mjozefcz): Remove this blacklist when OVS 2.12 will be released and
      # https://patchwork.ozlabs.org/patch/1102717/ merged.
      tempest_black_regex: "(^neutron_tempest_plugin.scenario.test_internal_dns.InternalDNSTest)"
      tempest_concurrency: 2
      devstack_localrc:
        Q_USE_PROVIDERNET_FOR_PUBLIC: true
        PHYSICAL_NETWORK: public
        ENABLE_CHASSIS_AS_GW: true
        OVN_L3_CREATE_PUBLIC_NETWORK: true
        OVN_DBS_LOG_LEVEL: dbg
        USE_PYTHON3: True
        DOWNLOAD_DEFAULT_IMAGES: false
        IMAGE_URLS: "http://download.cirros-cloud.net/0.4.0/cirros-0.4.0-x86_64-disk.img,https://cloud-images.ubuntu.com/releases/xenial/release/ubuntu-16.04-server-cloudimg-amd64-disk1.img"
        DEFAULT_IMAGE_NAME: cirros-0.4.0-x86_64-disk
        DEFAULT_IMAGE_FILE_NAME: cirros-0.4.0-x86_64-disk.img
        ADVANCED_IMAGE_NAME: ubuntu-16.04-server-cloudimg-amd64-disk1
        ADVANCED_INSTANCE_TYPE: ds512M
        ADVANCED_INSTANCE_USER: ubuntu
        BUILD_TIMEOUT: 784
      devstack_plugins:
        networking-ovn: https://opendev.org/openstack/networking-ovn
        neutron-tempest-plugin: https://opendev.org/openstack/neutron-tempest-plugin
        octavia: https://opendev.org/openstack/octavia
      zuul_copy_output:
        '{{ devstack_base_dir }}/data/ovs': 'logs'
      extensions_to_txt:
        db: true
      devstack_services:
        br-ex-tcpdump: true
        br-int-flows: true
        c-api: true
        c-sch: true
        c-vol: true
        dstat: true
        g-api: true
        g-reg: true
        keystone: true
        n-api-meta: true
        n-api: true
        n-cauth: true
        n-cond-cell1: true
        n-cpu: true
        n-novnc-cell1: true
        n-sch: true
        n-super-cond: true
        networking-ovn-metadata-agent: true
        o-api: true
        o-hk: true
        ovn-controller: true
        ovn-northd: true
        ovn-octavia: true
        ovs-vswitchd: true
        ovsdb-server: true
        placement-api: true
        q-svc: true
        q-dns: true
        c-bak: false
        etcd: false
        peakmem_tracker: false
        q-agt: false
        q-dhcp: false
        q-l3: false
        q-meta: false
        q-metering: false
        s-account: false
        s-container-sync: false
        s-container: false
        s-object: false
        s-proxy: false

- job:
    name: networking-ovn-multinode-base
    description: Base multinode job for devstack/tempest based networking-ovn jobs.
    abstract: true
    parent: tempest-multinode-full-py3
    timeout: 10800
    required-projects:
      - openstack/devstack-gate
      - openstack/networking-ovn
      - openstack/neutron
      - openstack/neutron-tempest-plugin
      - openstack/octavia
      - openstack/tempest
    irrelevant-files:
      - ^(test-|)requirements.txt$
      - ^.*\.rst$
      - ^doc/.*$
      - ^releasenotes/.*$
      - ^setup.cfg$
      - ^tools/.*$
      - ^tox.ini$
      - ^vagrant/.*$
      - ^migration/.*$
      - ^networking_ovn/locale/.*$
    roles:
      - zuul: zuul/zuul-jobs
      - zuul: openstack/neutron-tempest-plugin
    pre-run: playbooks/multinode-setup.yaml
    vars:
      devstack_localrc:
        Q_USE_PROVIDERNET_FOR_PUBLIC: true
        PHYSICAL_NETWORK: public
        ENABLE_CHASSIS_AS_GW: true
        OVN_L3_CREATE_PUBLIC_NETWORK: true
        OVN_DBS_LOG_LEVEL: dbg
        DOWNLOAD_DEFAULT_IMAGES: false
        IMAGE_URLS: "http://download.cirros-cloud.net/0.4.0/cirros-0.4.0-x86_64-disk.img,https://cloud-images.ubuntu.com/releases/xenial/release/ubuntu-16.04-server-cloudimg-amd64-disk1.img"
        DEFAULT_IMAGE_NAME: cirros-0.4.0-x86_64-disk
        DEFAULT_IMAGE_FILE_NAME: cirros-0.4.0-x86_64-disk.img
        ADVANCED_IMAGE_NAME: ubuntu-16.04-server-cloudimg-amd64-disk1
        ADVANCED_INSTANCE_TYPE: ds512M
        ADVANCED_INSTANCE_USER: ubuntu
        BUILD_TIMEOUT: 784
      devstack_plugins:
        networking-ovn: https://opendev.org/openstack/networking-ovn
        neutron-tempest-plugin: https://opendev.org/openstack/neutron-tempest-plugin
        octavia: https://opendev.org/openstack/octavia
      zuul_copy_output:
        '{{ devstack_base_dir }}/data/ovs': 'logs'
      extensions_to_txt:
        db: true
      devstack_services:
        c-bak: false
        etcd: false
        br-ex-tcpdump: true
        br-int-flows: true
        networking-ovn-metadata-agent: true
        o-api: true
        o-hk: true
        ovn-controller: true
        ovn-northd: true
        ovn-octavia: true
        ovs-vswitchd: true
        ovsdb-server: true
        placement-api: true
        peakmem_tracker: false
        q-svc: true
        q-agt: false
        q-dhcp: false
        q-l3: false
        q-meta: false
        q-metering: false
        # When running python3 Swift should be disabled for now
        s-account: false
        s-container: false
        s-object: false
        s-proxy: false
    group-vars:
      subnode:
        devstack_services:
          ovn-controller: true
          ovn-northd: false
          ovn-octavia: false
          ovs-vswitchd: true
          ovsdb-server: true
          # NOTE(slaweq): it's just to check if this will force devstack to
          # configure neutron and ML2 plugin on subnodes
          q-fake: true
          q-svc: false
          q-agt: false
          q-dhcp: false
          q-l3: false
          q-meta: false
          q-metering: false
          networking-ovn-metadata-agent: true
        devstack_localrc:
          Q_USE_PROVIDERNET_FOR_PUBLIC: true
          PHYSICAL_NETWORK: public
          ENABLE_CHASSIS_AS_GW: false
          OVN_DBS_LOG_LEVEL: dbg
          USE_PYTHON3: True

- job:
    name: networking-ovn-tempest-dsvm-ovs-master
    description: Job testing for devstack/tempest testing networking-ovn with OVN master branch
    parent: networking-ovn-base
    vars:
      devstack_localrc:
        OVN_BRANCH: master

- job:
    name: networking-ovn-tempest-dsvm-ovs-release
    description: Job testing for devstack/tempest testing networking-ovn with the latest released OVN branch
    parent: networking-ovn-base
    vars:
      devstack_localrc:
        OVN_BRANCH: branch-2.11

- job:
    name: networking-ovn-tempest-dsvm-ovs-release-python2
    description: Job testing for devstack/tempest testing networking-ovn with the latest released OVN branch
    parent: networking-ovn-base
    vars:
      devstack_localrc:
        OVN_BRANCH: branch-2.11
        USE_PYTHON3: False

- job:
    name: networking-ovn-tempest-dsvm-ovs-master-fedora
    description: Job testing for devstack/tempest testing networking-ovn with OVN master branch and Fedora
    parent: networking-ovn-tempest-dsvm-ovs-master
    nodeset: devstack-single-node-fedora-latest

- job:
    name: networking-ovn-rally-task
    parent: rally-task-at-devstack
    required-projects:
      - name: openstack/devstack
      - name: openstack/devstack-gate
      - name: openstack/rally
      - name: openstack/rally-openstack
      - name: openstack/networking-ovn
    irrelevant-files:
      - ^(test-|)requirements.txt$
      - ^.*\.rst$
      - ^doc/.*$
      - ^releasenotes/.*$
      - ^setup.cfg$
      - ^tools/.*$
      - ^tox.ini$
      - ^vagrant/.*$
      - ^migration/.*$
      - ^networking_ovn/locale/.*$
    vars:
      devstack_plugins:
        rally-openstack: https://opendev.org/openstack/rally-openstack
        networking-ovn: https://opendev.org/openstack/networking-ovn
      zuul_copy_output:
        '{{ devstack_base_dir }}/data/ovs': 'logs'
      extensions_to_txt:
        db: true
      devstack_services:
        ovn-northd: true
        ovn-controller: true
        networking-ovn-metadata-agent: true
        br-ex-tcpdump: true
        br-int-flows: true
        q-dhcp: false
        q-l3: false
        q-agt: false
        q-meta: false
        q-metering: false
      devstack_localrc:
        USE_PYTHON3: true
        PHYSICAL_NETWORK: public
        Q_USE_PROVIDERNET_FOR_PUBLIC: true
        ENABLE_CHASSIS_AS_GW: true
        OVN_L3_CREATE_PUBLIC_NETWORK: true
        OVN_BRANCH: master
      devstack_local_conf:
        post-config:
          "${RALLY_CONF_DIR}/${RALLY_CONF_FILE}":
            openstack:
              neutron_bind_l2_agent_types: "OVN Controller Gateway agent"
      rally_task: rally-jobs/ovn.yaml
    timeout: 7800

- job:
    name: networking-ovn-tripleo-ci-centos-7-containers-multinode
    parent: tripleo-ci-base-multinode
    vars:
      nodes: 1ctlr
      featureset: '010'
    irrelevant-files:
      - ^(test-|)requirements.txt$
      - ^.*\.rst$
      - ^doc/.*$
      - ^releasenotes/.*$
      - ^setup.cfg$
      - ^tools/.*$
      - ^tox.ini$
      - ^vagrant/.*$
      - ^migration/.*$
      - ^networking_ovn/locale/.*$

- job:
    name: networking-ovn-tempest-slow
    parent: networking-ovn-multinode-base
    vars:
      tox_envlist: slow-serial
      tempest_test_regex: ""
      # TODO(slaweq): remove test_port_security_macspoofing_port test from
      # blacklist when bug https://bugs.launchpad.net/tempest/+bug/1728886
      # will be fixed
      tempest_black_regex: "(?:tempest.scenario.test_network_basic_ops.TestNetworkBasicOps.test_port_security_macspoofing_port)"

- job:
    name: networking-ovn-tempest-full-multinode-ovs-master
    parent: networking-ovn-multinode-base
    vars:
      tox_envlist: all-plugin
      tempest_test_regex: "^(?!.*\
          (?:.*\\[.*slow.*\\])|\
          (?:tempest.api.network.admin.test_quotas.QuotasTest.test_lbaas_quotas.*)|\
          (?:tempest.api.network.test_load_balancer.*)|\
          (?:tempest.scenario.test_load_balancer.*)|\
          (?:tempest.api.network.admin.test_load_balancer.*)|\
          (?:tempest.api.network.admin.test_lbaas.*)|\
          (?:tempest.api.network.test_fwaas_extensions.*)|\
          (?:tempest.api.network.test_metering_extensions.*)|\
          (?:tempest.thirdparty.boto.test_s3.*)|\
          (?:tempest.scenario.test_network_basic_ops.TestNetworkBasicOps.test_port_security_macspoofing_port)|\
          (?:tempest.api.identity*)|\
          (?:tempest.api.image*)|\
          (?:tempest.api.volume*)|\
          (?:tempest.api.compute.images*)|\
          (?:tempest.api.compute.keypairs*)|\
          (?:tempest.api.compute.certificates*)|\
          (?:tempest.api.compute.flavors*)|\
          (?:tempest.api.compute.test_quotas*)|\
          (?:tempest.api.compute.test_versions*)|\
          (?:tempest.api.compute.volumes*)|\
          (?:tempest.api.compute.admin.test_flavor*)|\
          (?:tempest.api.compute.admin.test_volume*)|\
          (?:tempest.api.compute.admin.test_hypervisor*)|\
          (?:tempest.api.compute.admin.test_aggregate*)|\
          (?:tempest.api.compute.admin.test_quota*)|\
          (?:tempest.scenario.test_volume*))\
          ((^neutron_tempest_plugin.api)|\
          (^neutron_tempest_plugin.scenario)|\
          (tempest.(api|scenario|thirdparty))).*$"
      # TODO(mjozefcz): Remove DNS related tessts when OVS 2.12 will be
      # released and https://patchwork.ozlabs.org/patch/1102717/ merged.
      # TODO(slaweq): live_migration related test from the blacklist when bug
      # https://bugzilla.redhat.com/show_bug.cgi?id=1716335 will be fixed
      tempest_black_regex: "\
          (^neutron_tempest_plugin.scenario.test_internal_dns.InternalDNSTest)|\
          (^neutron_tempest_plugin.api.test_ports.PortsTestJSON.test_create_update_port_with_dns_name)|\
          (^tempest.api.compute.admin.test_live_migration.LiveAutoBlockMigrationV225Test)|\
          (^tempest.api.compute.admin.test_live_migration.LiveMigrationTest)"
      devstack_localrc:
        OVN_BRANCH: master
    group-vars:
      subnode:
        devstack_localrc:
          OVN_BRANCH: master
